<template>
  <!-- 
    整页表单的分片表单
    v 1.0
    2021-05-12
    Lufthafen
  -->
  <a-form-model
    :label-col="labelCol"
    :model="form"
    :rules="rules"
    :wrapper-col="wrapperCol"
    ref="form"
  >
    <a-spin :spinning="loading">
      <a-icon slot="indicator" spin type="loading" />
      <!-- 表单控件 -->
      <!-- ... -->
      <a-row :gutter="16" type="flex">
        <a-col :span="24">
          <a-form-model-item class="ant-row-flex" label="初始等级" prop="patrolInfo.initGrade">
            <a-radio-group
              :disabled="true"
              button-style="solid"
              v-model="form.patrolInfo.initGrade"
            >
              <a-radio-button
                :key="item.code"
                :value="+item.code"
                v-for="item in codes.houseInitGrade"
              >{{ item.value }}</a-radio-button>
            </a-radio-group>
          </a-form-model-item>
        </a-col>
        <a-col :span="24">
          <a-form-model-item class="ant-row-flex" label="损坏等级" prop="patrolInfo.damageGrade">
            <a-radio-group button-style="solid" v-model="form.patrolInfo.damageGrade">
              <a-radio-button
                :key="item.code"
                :value="+item.code"
                v-for="item in codes.houseDamageGrade"
              >{{ item.value }}</a-radio-button>
            </a-radio-group>
          </a-form-model-item>
        </a-col>
        <a-col :span="24">
          <a-form-model-item class="ant-row-flex" label="综合等级" prop="patrolInfo.comprehensiveGrade">
            <a-radio-group button-style="solid" v-model="form.patrolInfo.comprehensiveGrade">
              <a-radio-button
                :key="item.code"
                :value="+item.code"
                v-for="item in codes.houseGrade"
              >{{ item.value }}</a-radio-button>
            </a-radio-group>
          </a-form-model-item>
        </a-col>
      </a-row>
    </a-spin>
  </a-form-model>
</template>
<script>
/* 表单内容默认值 */
const defaultForm = {
  /* ... */
  patrolInfo: {
    initGrade: '1',
    damageGrade: '1',
    comprehensiveGrade: '1',
  },
};

export default {
  props: ['param'],

  data() {
    return {
      labelCol: { flex: '150px' },
      wrapperCol: { flex: '1' },

      /** 表单数据 */
      form: {
        ...defaultForm,
      },
      /** 验证格式 */
      rules: {
        /* ... */
        'patrolInfo.initGrade': [{ required: true, message: '请选择初始等级' }],
        'patrolInfo.damageGrade': [{ required: true, message: '请选择损坏等级' }],
        'patrolInfo.comprehensiveGrade': [{ required: true, message: '请选择综合等级' }],
      },

      /** 加载异步数据状态 */
      loading: false,

      /** 其他成员属性 */
      /* ... */
      codes: {
        houseInitGrade: [],
        houseDamageGrade: [],
        houseGrade: [],
      },
    };
  },
  watch: {
    '$root.transfer.completedYear'(value) {
      //初始等级无法手动更改，由房屋详情的竣工日期决定：2000年之后竣工的为一级，1995年~1999年竣工的为二级，1980年~1994年竣工的为三级，早于1980年竣工的为四级。选择房屋竣工日期后，初始等级会自动填充。
      console.log('patrol-grade:' + value);
      var year = +value;
      if (year > 1999) {
        this.form.patrolInfo.initGrade = 1;
      }
      if (year > 1994 && year < 2000) {
        this.form.patrolInfo.initGrade = 2;
      }
      if (year > 1979 && year < 1995) {
        this.form.patrolInfo.initGrade = 3;
      }
      if (year < 1980) {
        this.form.patrolInfo.initGrade = 4;
      }
    },
  },
  async created() {
    this.onFillData();
  },

  methods: {
    /**
     * 必要的方法
     * 在打开编辑页时允许填充数据
     */
    async onFillData() {
      this.loading = true;
      {
        await this.onLoadCodes();
        /** 将默认数据覆盖到form */
        const record = this.param && this.param.record;
        const form = this.$_.cloneDeep(defaultForm);

        if (record) {
          this.$_.giveDeep(form, record);
        }
        this.form = form;
      }
      this.loading = false;
    },

    /**
     * 必要方法
     * 验证表单并获取表单数据
     */
    onGetData() {
      return new Promise((reslove, reject) => {
        this.$refs.form.validate((valid, err) => {
          if (valid) {
            const record = this.$_.cloneDeep(this.form);

            /** 验证通过后可以对数据进行转换得到想要提交的格式 */
            /* ... */

            reslove(record);
          } else {
            reject(err);
          }
        });
      });
    },

    /**
     * 必要的方法
     * 在外部窗口关闭或重置时对表单验证进行初始化
     */
    onResetFields() {
      setTimeout(() => {
        this.$refs.form.resetFields();

        /** 在这里可以初始化当前组件中其他属性 */
        /* ... */
      }, 300);
    },

    /** 当前组件的其他方法 */
    /* ... */
    onLoadCodes() {
      return this.$api
        .sysDictTypeDropDowns({
          code: ['dic_house_patrol_init_grade', 'dic_house_patrol_damage_grade', 'dic_house_grade'],
        })
        .then(({ data: { dic_house_patrol_init_grade, dic_house_patrol_damage_grade, dic_house_grade } }) => {
          this.codes = {
            houseInitGrade: dic_house_patrol_init_grade,
            houseDamageGrade: dic_house_patrol_damage_grade,
            houseGrade: dic_house_grade,
          };
        });
    },
  },
};
</script>